<?php

/*
  Copyright (C) 2008 www.ads-ez.com

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or (at
  your option) any later version.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

if (!class_exists('EzAdminPro')) {

  require 'EzAdmin.php';

  class EzAdminPro extends EzAdmin {

    function renderTipDivs($isPro) {
      parent::renderTipDivs($isPro);
      $name = $this->plg['value'];
      $share = !empty($this->plg['share']);
      if ($share) {
        echo "<div id='share' style='padding:5px;display:none;'>
$name has an ad space sharing option, if you would like to support its future development. It gives you an option to share a small fraction of your ad slots (suggested value is 5%) to show the author's ads. Use the option (in 'Support $name by Donating Ad Space') below to change the value from the default 0% to turn it on. You could also enable an unobtrusive, powered-by sort of link under an ad block by clicking on the right radio box. Don't worry, the defaults are: 0% sharing, and no powered-by links.
</div>";
      }
      else {
        echo "<div id='share' style='padding:5px;display:none;'>
Some of my plugins have an option to put a small back-link to the author's blog at the bottom of your pages or invisible ones under the first two LaTeX equations (if any) on your page. Please consider turning it on using the appropriate option below, if you find such an option. The default is always OFF so that no banklinking is done without your explicit permission.
</div>";
      }
    }

    function renderSupport() {
      echo '<div style="background-color:#fdf;padding:5px;border: solid 1px #bab;margin:5px;">
';
      $plg = $this->plg;
      $slug = $this->slug;
      $value = $plg['value'];
      $info = $this->getPlgInfo();
      $slug = str_replace('-pro', '', $slug);
      if ($slug == 'easy-latex') {
        $slugDat = 'easy-wp-latex.dat';
      }
      else {
        $slugDat = "$slug.dat";
      }
      if (strpos($slug, 'adsense') === false) {
        $data = @unserialize(gzinflate(file_get_contents("http://api.wp-plus.org/plugins/$slugDat")));
      }
      if (empty($data)) {
        $data = (object) array("name" => $info['Title'], "version" => "0.00");
      }
      $url = 'http://www.thulasidas.com/plugins/' . $slug;
      $link = '<a href="' . $url . '#faq" target="_blank" class="popup" data-height="1024">' . $value . '</a>';
      echo "&nbsp;<a href='http://support.thulasidas.com' class='popup' title='";
      _e('Ask a support question (in English or French only) via ezSupport @ $0.95', 'easy-common');
      echo "'><img src='{$this->cdn}/ezsupport.png' class='alignright' alt='ezSupport Portal'/></a>";
      printf(__("If you need help with %s, please read the FAQ section on the %s page. It may answer all your questions.", 'easy-common'), $value, $link);
      echo "<br style='line-height: 20px;'/>";
      _e("Or, if you still need help, you can raise a support ticket.", 'easy-common');
      echo "&nbsp;<a href='http://support.thulasidas.com' class='popup' title='";
      _e('Ask a support question (in English or French only) via ezSupport @ $0.95', 'easy-common');
      echo "'>";
      _e("[Request Paid Support]", 'easy-common');
      echo "</a>&nbsp;<small><em>[";
      _e('Using our ezSupport Ticket System.', 'easy-common');
      echo "&nbsp;<a href='http://www.thulasidas.com/packages/ezsupport' class='popup' data-height='1024'>Link</a>]</em></small>";
      $_SESSION['ezSupport'] = $info['Info'];
      if (!empty($info['Version'])) {
        if ((float) $data->version > (float) $info['Version']) {
          $s1 = __('Get Update', 'easy-common');
          $s2 = __('Change Log', 'easy-common');
          $s3 = __('Please update your plugin.', 'easy-common');
          $s4 = __('If you have downloaded the update, please upload it here', 'easy-common');
          $warning = "<span style'color:red'>You are using $slug {$info['Version']}. The current version is {$data->version}. &nbsp; [<a class='popup' href='http://buy.thulasidas.com/pro/ez-update.php'>$s1</a>]</span> &nbsp; [<a class='popup' href='$url#changelog'>Change Log</a>]";
          $notice = "<div class='error'><p><b><em>{$data->name}</em>: $warning</b></p></div>";
          if ($slug != 'easy-paypal') {
            echo "$notice";
          }
          echo "<br /><b>$s3 $warning</b>";
          echo "<form method='post' enctype='multipart/form-data' action='update.php?action=ezupdate-plugin'>
<b>$s4</b>:&nbsp; <input type='file' id='pluginzip' name='pluginzip' style='background-color:white' />
<input type='submit' value='Install Now' />
</form>";
        }
        else {
          echo "<small style='float:right'><em>[";
          printf('%s Pro (V%s)', $value, $info['Version']);
          echo "]</em></small>";
        }
      }
      echo "</div>";
    }

    function renderWhyPro($short = false) {

    }

  }

}
